// 18 Feb 2007
// Copyright (c) 2007, Guillermo Gutierrez
// Released under the GPL license
// http://www.gnu.org/copyleft/gpl.html
// Script de compactacion automatica de batallas de ogame

    //Shipts properties
	var shiptsConsumption		= new Array('20','50','20','75','300','500','100','300','1','1000','0','1000','1','250');
	var shiptsSpeed			= new Array('10000','7500','12500','10000','15000','10000','2500','2000','100000000','5000','0','5000','100','10000');

	//Shipts costs
	var shiptsMetalCost		= new Array('2000','6000','3000','6000','20000','45000','10000','10000','0','50000','0','60000','5000000','30000');
	var shiptsCristalCost		= new Array('2000','6000','1000','4000','7000','15000','20000','6000','1000','25000','2000','50000','4000000','40000');
	var shiptsDeuteriumCost		= new Array('0','0','0','0','2000','0','10000','2000','0','15000','500','15000','1000000','15000');

    //Defenses costs
	var defensesMetalCost		= new Array('2000','1500','6000','20000','2000','50000','10000','50000');
	var defensesCristalCost		= new Array('0','500','2000','15000','6000','50000','10000','50000');
	var defensesDeuteriumCost	= new Array('0','0','0','2000','0','30000','0','0');

    //Report values containers
	//Atackers & Defenders info
	var atackerName 	 = new Array();
	var atackerTecnology     = new Array();
	var defenderName 	 = new Array();
	var defenderTecnology    = new Array();
	var atackerCount	 = 0;
	var defenderCount	 = 0;
	var rounds		 = 1;
	var loosesArr		 = new Array();

	//Rubbles info
	var rubbleMetal	 	 = 0;
	var rubbleCristal	 = 0;

	//looses info
	var defenderLoosesAmount = 0;
	var atackerLoosesAmount  = 0;

	//Stolen info
	var stolenMetal	 	 = 0;
	var stolenCristal	 = 0;
	var stolenDeuterium	 = 0;

	//Result Info
	var result_info		 = "";
	var date		 = "";
	var moon_probability	 = 0;
	var atackerRentability   = "";
	var atackerRentability2   = "";
	var defenderRentability  = "";
	var moon_and_defenses_info	 = "";
	var metalAtackersLooses = 0;
	var cristalAtackersLooses = 0;
	var deuteriumAtackersLooses = 0;
	var metalDefendersLooses = 0;
	var cristalDefendersLooses = 0;
	var deuteriumDefendersLooses = 0;

    //Paralel arrays for get the flotes
	var atackerInitialShipsType = new Array();
	var atackerFinalShipsType = new Array();
	var atackerInitialShipsNumber = new Array();
	var atackerFinalShipsNumber = new Array();
	var atackerAuxFinalShipsNumber = new Array();
	var defenderInitialShipsType = new Array();
	var defenderFinalShipsType = new Array();
	var defenderInitialShipsNumber = new Array();
	var defenderFinalShipsNumber = new Array();
	var defenderAuxFinalShipsNumber = new Array();
	var atackerCoords = new Array();
	var defenderCoords = new Array();

     //Colors for forums, we must get and set the options from the Grease monkey
	//For fleets
	var fleetAtackerColor = new Array('red', 'lime');
	var fleetDefenderColor = new Array('blue', 'orange');
	var infoColor = new Array('purple', 'skyblue');
	//For nicks
	var atackerNameColor = new Array('red', 'lime');
	var defenderNameColor = new Array('blue', 'orange');
	//For looses
	var totalAtackerLoosesColor = new Array('red','lime');
	var partialAtackerLoosesColor = new Array('green','limegreen');
	var totalDefenderLoosesColor = new Array('blue','orange');
	var partialDefenderLoosesColor = new Array('orangered','orangered');
	//For consumption
	var atackerConsumptionColor = new Array('red','lime');
	var defenderConsumptionColor = new Array('blue','orange');
	//For stolen resources
	var stolenColor = new Array('purple', 'skyblue');
	//For rentabilitys
	var atackerWithRecicleColor = new Array('green','yellow');
	var atackerWithOutRecicleColor = new Array('orangered','orangered');
	var defenderWithRecicleColor = new Array('brown','coral');

    const br= '<br>';

    const imageDefault= 'http://www.science.siu.edu/images/line-hr-eyes.gif';

    //Tags for html, phpBB, plain text, smf, vBulletin and phpBB3 :)
	var boldInit 		= new Array('<b>','[b]','','[b]','[b]','[b]');
	var boldEnd		= new Array('</b>','[/b]','','[/b]','[/b]','[/b]');
	var itallyInit		= new Array('<i>','[i]','','[i]','[i]','[i]');
	var itallyEnd		= new Array('</i>','[/i]','','[/i]','[/i]','[/i]');
	var crlf		= new Array('<br>','\n','\n','\n','\n','\n');
	var sizeInit		= new Array('<font size="#replace">','[size=#replace]','','[size=#replace]','[size=#replace]','[size=#replace]');
	var sizeEnd		= new Array('</font>', '[/size]','', '[/size]', '[/size]', '[/size]');
	var colorInit		= new Array('<font color="#replace">','[color=#replace]','','[color=#replace]','[color=#replace]','[color=#replace]');
	var colorEnd		= new Array('</font>','[/color]','','[/color]','[/color]','[/color]');
	var hr			= new Array('<img src="#replace" />','[img]#replace[/img]','','[img]#replace[/img]','[IMG]#replace[/IMG]','[IMG]#replace[/IMG]');
	var round_size		= new Array('3px','18','','14pt','3',150);
	var nick_size		= new Array('4px','19','','15pt','4',160);
	var section_size	= new Array('4px','17','','13pt','2',140);
	var resource_size	= new Array('4px','21','','17pt','6',180);
	var rentability_size	= new Array('4px','17','','13pt','2',140);

    //Options of report:)
    var color_skin = 1;
    var color_forum = 0;

    // Internationalization/Localization
    var   battletags = {};
    var   translation= {};
    const langsURL   = 'chrome://ogamecompactor/content/locale/';
    var   langsBattle= {
                        'Las siguientes flo': 'es',
                        'the following flee': 'en',
                        'As seguintes frota': 'pt',
                        'Le seguenti flotte': 'it',
                        'Les flottes suivan': 'fr',
                        'Folgende Flotten s': 'de',
			'urmatoarele flote ': 'ro'
                       };
    var   langsCodes = [ '', 'es', 'en', 'pt', 'it', 'fr', 'de', 'ga', 'ro' ];
    var   langsNames = [ 'Autoselect', 'Espaol', 'English', 'Portugues', 'Italiano', 'Franais', 'Deutsch', 'Galego', 'Romanian' ];

////////////////////////////////////////////////////////////////////////
// Convert an OGame number to integer (removing no digits characteres) //
/////////////////////////////////////////////////////////////////////////

function parseIntOGame(s)
{
  return parseInt(s.replace(/[^0-9\-]/g,''));
}

//////////////////////////////////////////////////////////
// Get the text between the begin text and the end text //
//////////////////////////////////////////////////////////

function get_from_to(strLine, begin, end) {

	return strLine.substring(strLine.indexOf(begin) + begin.length , strLine.indexOf(end));
}

////////////////////////////////////////////////////////
// Calculate and load battle translation              //
////////////////////////////////////////////////////////

function get_locale()
{
  // Load battle locale tags
  var langBattle= null;
  var items= document.getElementsByTagName("td");
  var title= items[0].innerHTML.substr(0,48);
  for(var key in langsBattle) {
    if(title.indexOf(key)>=0) {
      langBattle= langsBattle[key];
      break;
    }
  }
  
  if(!langBattle) throw new Error("OGame battle language unknow.");
  battletags= eval(GM_getContents(langsURL+langBattle+'/server.js'));
  // Load interface locale
  var lang= langsCodes[ GM_getValue('language', 0) ];
  if(lang=='') lang= langBattle;
  translation= eval(GM_getContents(langsURL+lang+'/client.js'));
}

// Retrieve translations
function t(name)
{
 return (name in translation) ? translation[name] : name;
}

// Retrieve battle tags
function tag(name)
{
 return (name in battletags) ? battletags[name] : name;
}

////////////////////////////////////////////////////////
// Get the date of the battle and show it more gentle //
////////////////////////////////////////////////////////

function get_battle_date () {

    var header = document.getElementsByTagName('td')[0].firstChild.nodeValue;
    var dateArr = new Array();
    dateArr = header.match(/(\d\d)-(\d\d) (\d\d:\d\d:\d\d)/);
    
    date = dateArr[2] + ' ' + t('of') + ' ' + t('$months')[parseInt(dateArr[1],10)-1] + t('at') + dateArr[3];
    return date;
}

////////////////////////////////////////////////////////
// Get the distance factor from Origin to Destination //
////////////////////////////////////////////////////////

function distance(origin, destination) {
	var dist = 0;
	var originArr = new Array();
	var destinationArr = new Array();
	//Clear the strings
	origin = origin.replace("(","");
	origin = origin.replace(")","");
	destination = destination.replace("(","");
	destination = destination.replace(")","");
	//Convert the cordinates to an array galaxy 0, system 1, planet 2
	originArr = origin.split(":");
	destinationArr = destination.split(":");
	if ( originArr[0] == destinationArr[0]) {
		//Same galaxy
		if ( originArr[1] == destinationArr[1]) {
			//Same system diferent planet
			dist = Math.abs(originArr[2] - destinationArr[2]) * 5 + 1000;
		}
		else {
			//Diferent System same galaxy
			dist = Math.abs(originArr[1] - destinationArr[1]) * 5 * 19 + 2700;
		}
	}
	else {
		//Diferent Galaxy
		dist = Math.abs(originArr[0] - destinationArr[0]) * 20000;
	}
	return dist;
}
function atackerConsumption (dist, minSpeed, player) {
	var duration = 0;
	var spd = 0;
	var searchPos;
	var basicCosumption = 0;
	var consumption = 0;
        var serverShiptsNames= tag('$ships');
	duration = Math.round((35000/10 * Math.sqrt(dist*10/minSpeed) + 10));
	for (var i=0; i<atackerInitialShipsType[player].length; i++) {
		//For each ship in the attack :)
		searchPos = -1;
		for ( var j=0;j<serverShiptsNames.length; j++ ) {
			if (atackerInitialShipsType[player][i] == serverShiptsNames[j]) {
				searchPos = j;
			 	break;
			}
		}
		if (searchPos != -1) {
			spd = 35000/(duration * 1 - 10) * Math.sqrt(dist*10/shiptsSpeed[searchPos]);
			basicConsumption = shiptsConsumption[searchPos] * atackerInitialShipsNumber[player][i];
			consumption += basicConsumption * dist / 35000 * ((spd / 10) + 1) * ((spd / 10) + 1);
		}
	}
	return Math.round(consumption) + 1;
}
function defenderConsumption (dist, minSpeed, player) {
	var duration = 0;
	var spd = 0;
	var searchPos;
	var basicCosumption = 0;
	var consumption = 0;
    var serverShiptsNames= tag('$ships');
	duration = Math.round((35000/10 * Math.sqrt(dist*10/minSpeed) + 10));
	for (var i=0; i<defenderInitialShipsType[player].length; i++) {
		//For each ship in the attack :)
		searchPos = -1;
		for ( var j=0;j<serverShiptsNames.length; j++ ) {
			if (defenderInitialShipsType[player][i] == serverShiptsNames[j]) {
				searchPos = j;
			 	break;
			}
		}
		if (searchPos != -1) {
			spd = 35000/(duration * 1 - 10) * Math.sqrt(dist*10/shiptsSpeed[searchPos]);
			basicConsumption = shiptsConsumption[searchPos] * defenderInitialShipsNumber[player][i];
			consumption += basicConsumption * dist / 35000 * ((spd / 10) + 1) * ((spd / 10) + 1);
		}
	}
	return Math.round(consumption) + 1;
}

/////////////////////////////////////////////////////////////////
// Get the final flotes from all players and store in a matrix //
/////////////////////////////////////////////////////////////////

function get_final_flotes () {
	var html = document.getElementsByTagName ('center');
	var strLine;
	var player = defenderCount;
 	var i;
	var j;
	var array_controler = 0;

	for (j=0;j< defenderCount; j++) {
		//Initialize the matrix
		defenderFinalShipsNumber[j] = new Array();
	}
	for (i=html.length -1; i >= html.length - (defenderCount)  ; i--) {
		array_controler = 0;
		//Get defenders flotes
		strLine = html[i].innerHTML;
		player --;
		if (strLine.search(tag('destroyed')) != -1) {
			//The defensor was destroyed
			defenderFinalShipsType[player] = '';
			defenderAuxFinalShipsNumber[player] = '';

		}
		else {
			defenderFinalShipsType[player]=get_flote_type_from_string (strLine);
			defenderAuxFinalShipsNumber[player]=get_flote_number_from_string(strLine);
		}

		for (j=0;j<defenderInitialShipsType[player].length;j++) {
				if (defenderFinalShipsType[player][array_controler] == defenderInitialShipsType[player][j]) {
					//The ship type has survivors :)
					defenderFinalShipsNumber[player][j]=defenderAuxFinalShipsNumber[player][array_controler];
					array_controler++;
				}
				else {
					defenderFinalShipsNumber[player][j] = 0;
				}
		}
		//Check for set the destroyed player flote
		if (defenderAuxFinalShipsNumber[player]=='') {
			defenderFinalShipsType[player] = defenderInitialShipsType[player]
			for (j=0;j<defenderInitialShipsNumber[player].length;j++)
			defenderFinalShipsNumber[player][j] = 0;
		}
	}
	player = atackerCount;
	for (j=0;j< atackerCount; j++) {
		//Initialize the matrix
		atackerFinalShipsNumber[j] = new Array();
	}

	for (i=html.length-(defenderCount+1);i>=html.length-(defenderCount+atackerCount);i--) {
		//Get atackers flotes
		strLine = html[i].innerHTML;
		player --;
		if (strLine.search(tag('destroyed')) != -1) {
			//The defensor was destroyed
			atackerFinalShipsType[player] = '';
			atackerFinalShipsNumber[player] = '';

		}
		else {
			atackerFinalShipsType[player] = get_flote_type_from_string (strLine);
			atackerAuxFinalShipsNumber[player] = get_flote_number_from_string (strLine);
		}
		arrayController = 0;
		for (j = 0; j < atackerInitialShipsType[player].length; j++) {
			if (atackerInitialShipsType[player][j] == atackerFinalShipsType[player][arrayController] ) 	{
				atackerFinalShipsNumber[player][j]=atackerAuxFinalShipsNumber[player][arrayController];
				arrayController++;
			}
			else {
				atackerFinalShipsNumber[player][j] = 0;
			}
		}
		//Check for set the destroyed player flote

		if (atackerAuxFinalShipsNumber[player]==undefined) {
			atackerFinalShipsType[player] = atackerInitialShipsType[player];
			atackerFinalShipsNumber[player] = new Array();
			for (j=0;j<atackerInitialShipsNumber[player].length;j++) {
				atackerFinalShipsNumber[player][j] = 0;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////
// Get the initial info about players: flotes, name, tecnology //
/////////////////////////////////////////////////////////////////

function get_names_and_flotes () {
	//Extract the names of attackers and defenders.
	var html = document.getElementsByTagName ('center');
	var strLine;
    var atackertag      = tag('attacker');
    var defendertag     = tag('defender');
    var destroytag      = tag('destroyed');
    var endtecnologytag = tag('EndTech1');
    var endtecnology2tag= tag('EndTech2');
	for (var i = 0; i <= html.length - 1; i++) {
		strLine = html[i].innerHTML;
		
		if ( strLine.search(atackertag ) != -1 && strLine.search(br) != -1 && strLine.search(destroytag) == -1) {
			//Get only the atacker first aparition
			atackerName[atackerCount] = get_from_to(strLine,atackertag ," (");
			atackerInitialShipsType[atackerCount]=get_flote_type_from_string(strLine);
			atackerInitialShipsNumber[atackerCount]=get_flote_number_from_string(strLine);
			atackerTecnology[atackerCount] = get_from_to(strLine,br,endtecnologytag);
			atackerCoords[atackerCount] = get_from_to(strLine,'[',']');
			atackerCount++;
		}
		else if (strLine.search(defendertag ) != -1 && strLine.search(br) != -1 && strLine.search(destroytag) == -1) {
			//Get only the defender first aparition
			defenderName[defenderCount] = get_from_to(strLine,defendertag," (");
			defenderInitialShipsType[defenderCount]=get_flote_type_from_string (strLine);
			defenderInitialShipsNumber[defenderCount]=get_flote_number_from_string (strLine);
			defenderTecnology[defenderCount] = get_from_to(strLine,br,endtecnologytag);
			defenderCoords[defenderCount] = get_from_to(strLine,'[',']');
			defenderCount++;
		}
		else if (strLine.search(defendertag) != -1 && strLine.search(br) != -1 && strLine.search(destroytag) != -1 && defenderCount == 0) {
			//Get the defender when s/he didn't have float and defenses
			defenderName[defenderCount] = get_from_to(strLine,defendertag, " (");
			defenderInitialShipsType[defenderCount] = tag('NoShipsDefenses');
			defenderInitialShipsNumber[defenderCount] = '';
			defenderTecnology[defenderCount]=get_from_to(strLine,br,endtecnology2tag);
			defenderCoords[defenderCount] = get_from_to(strLine,'[',']');			
			defenderCount++;
		}
		
	}
}

/////////////////////////////////////////////////////////
// Get the flotes type from one report realy useful :D //
/////////////////////////////////////////////////////////

function get_flote_type_from_string (strLine) {
//Get the flote type from a string
	var storeArray    = new Array();
	var floteTypeArray= new Array();
    var amountag      = tag('amount');
	storeArray = strLine.split('<th>');
	for (var i=0; i < storeArray.length && storeArray[i+2].search(amountag) == -1; i++) {
		//Clean the string before store
		floteTypeArray[i] = storeArray[i+2].replace('</th>','').replace('</tr><tr>','');
	}
	return floteTypeArray;
}

////////////////////////////////////////////////////////////
// Get the flotes number from one report really useful :D //
////////////////////////////////////////////////////////////

function get_flote_number_from_string (strLine) {
//Get the flote number from a string
	var storeArray = new Array();
	var floteNumberArray = new Array();
	var array_controller = 0;
    var amountag         = tag('amount');
    var damagetag        = tag('damage');
	storeArray = strLine.split('<th>');
	for (var i = 0; i < storeArray.length && storeArray[i].search(amountag) == -1; i++) {
		array_controller++;
	}
	array_controller++;
	for (i=array_controller; i < storeArray.length && storeArray[i].search(damagetag) == -1; i++) {
		//Clean the string before store
		floteNumberArray[i-array_controller] = parseIntOGame(storeArray[i].replace('</th>','').replace('</tr><tr>',''));
	}
	return floteNumberArray;
}

//////////////////////////////
// Get the number of rounds //
//////////////////////////////

function get_rounds() {
	var html = document.getElementsByTagName ('tbody');
	var players = (atackerCount+defenderCount);
	var strLines = html[0].innerHTML;
	rounds = strLines.split(tag('round')).length -1;
	if (rounds == 0) {
		rounds++;
	}
}

////////////////////////////////////////////////////////////////////////////
// Get general info about the battle like winner, stolen resources etc... //
////////////////////////////////////////////////////////////////////////////

function get_battle_info_result() {
	var html = document.getElementsByTagName ('p');
	var strLine;
	for (var i = 0; i <= html.length - 1; i++) {
		strLine = html[i].innerHTML;
		if ((strLine.search(tag('result')) != -1) || (strLine.search(tag('BattleDraw')) != -1)) {
			//Search for win loose or draw zone to recover winner info
            var battle= get_from_to(strLine,'',br);
            if (battle.search(tag('BattleWin')) != -1)
              result_info= t('BattleWin');
            else if (battle.search(tag('BattleLoose')) != -1)
              result_info= t('BattleLoose');
            else
              result_info= t('BattleDraw');
		}
		if ((strLine.search(tag('result')) != -1) && (strLine.search(tag('AttackerResult')))) {
			//Search for stolenResources when atacker win
			stolenMetal = parseIntOGame(get_from_to(strLine, tag('Capture'),tag('Metal')));
			stolenCristal = parseIntOGame(get_from_to(strLine,tag('Metal'),tag('Crystal')));
			stolenDeuterium = parseIntOGame(get_from_to(strLine,tag('Crystal'),tag('Deuterium')));
		}
		if (strLine.search(tag('rubble')) != -1)  {
			//Search for rubble
			rubbleMetal  = parseIntOGame(get_from_to(strLine, tag('rubble'),tag('MetalRubble')));
			rubbleCristal= parseIntOGame(get_from_to(strLine, tag('MetalRubble'),tag('CrystalRubble')));
		}
		if (strLine.search(tag('moon')) != -1) {
			moon_probability = parseIntOGame(get_from_to(strLine,tag('moon'),'%'));
			strLine = strLine+ '<br>';
			moon_and_defenses_info = strLine.substring(strLine.indexOf(tag('CrystalRubble')) + (tag('CrystalRubble').length +1),strLine.lastIndexOf(br)).replace('<b>','').replace('</b>','');
		}
		//Get atacker looses value
		atackerLoosesAmount = parseIntOGame(get_from_to(strLine,tag('AttackerLooses'),tag('units')));
		//Get defender looses value
		defenderLoosesAmount= parseIntOGame(strLine.substring(strLine.indexOf(tag('DefenderLooses')) + (tag('DefenderLooses').length +1),strLine.lastIndexOf(tag('units'))-1));
	}
}

///////////////////////////////////////////////
// Get the rentabilitys from the report data //
///////////////////////////////////////////////

function get_rentabilitys () {
	var rubbleAmount = parseInt(rubbleCristal) + parseInt(rubbleMetal);
	if (isNaN(stolenMetal)) {
		stolenMetal = 0;
	}
	if (isNaN(stolenCristal)) {
		stolenCristal = 0;
	}
	if (isNaN(stolenDeuterium)) {
		stolenDeuterium = 0;
	}
	var stolenAmount = parseInt(stolenMetal) + parseInt(stolenCristal) + parseInt(stolenDeuterium);
	if (isNaN(rubbleAmount)) {
		rubbleAmount = 0;
	}
	if (atackerLoosesAmount == 0) {
		atackerRentability = 'MaxRentability';
		atackerRentability2 = 'MaxRentability';
	}
	else {
		if (isNaN(stolenAmount))
		{
			//This must fix the bug when nothing is stolen
			stolenAmount = 0;
		}
		atackerRentability = ((((rubbleAmount + stolenAmount)- atackerLoosesAmount) / atackerLoosesAmount)*100);
		atackerRentability = Math.round(parseInt(atackerRentability)) + '%';
		atackerRentability2 = (((stolenAmount- atackerLoosesAmount) / atackerLoosesAmount)*100);
		atackerRentability2 = Math.round(parseInt(atackerRentability2)) + '%';
	}
	if (defenderLoosesAmount == 0 && stolenAmount == 0) {
		defenderRentability = 'MaxRentability';
	}
	else {
		defenderRentability = ((rubbleAmount - (defenderLoosesAmount + stolenAmount)) / (defenderLoosesAmount + stolenAmount))*100;
		defenderRentability = Math.round(parseInt(defenderRentability)) + '%';
	}
}

////////////////////////////////////////////////////////////////////////
// based in a function from 					      //
// http://www.forosdelweb.com/showthread.php?postid=265553#post265553 //
// put dot as separator :)					      //
////////////////////////////////////////////////////////////////////////

function formatNmb(num){
    var sRes = "";
    var sign = "";
    if (parseInt(num) < 0) {
	sign = "-";
	num = parseInt(num) * -1
    }
    //Convert to string and remove espaces
    nNmb = '' + parseInt(num) + '';

    for (var j, i = nNmb.length - 1, j = 0; i >= 0; i--, j++)
     sRes = nNmb.charAt(i) + ((j > 0) && (j % 3 == 0)? ".": "") + sRes;

    return sign + sRes;
}

////////////////////////////////////
// create the flotes report zone  //
////////////////////////////////////

function createFloteView (fleetType, fleetInitialNumber, fleetFinalNumber, fleetColor, loosesColor, type_preference) {
	//Initizlize the report
	var fleetReport = '';
	for (var position=0; position < fleetType.length; position++) {
			//Calculate type, initial and final fleet row
			type = fleetType[position];
			initialNumber = formatNmb(fleetInitialNumber[position]);
			lostNumber   = formatNmb((fleetInitialNumber[position]-fleetFinalNumber[position]));
			//Set shipt color for initial representation
			fleetReport = fleetReport + fleetType[position] + ' ' +  colorInit[type_preference].replace('#replace', fleetColor);
			fleetReport = fleetReport + initialNumber + colorEnd[type_preference];
			//Set color for shipt looses
			fleetReport = fleetReport + colorInit[type_preference].replace('#replace', loosesColor) + t('lost')+ lostNumber + colorEnd[type_preference];
			fleetReport = fleetReport + crlf[type_preference];
	}
	return fleetReport;
}

function createPlayerName (playerName, view_coords, color, size, type, coords) {
	//Initialize the string
	nameCreated = '';
	if (view_coords) {
		nameCreated = colorInit[type].replace('#replace', color) + sizeInit[type].replace('#replace',size);
		nameCreated = nameCreated + playerName + ' ' + sizeEnd[type] + colorEnd[type] + boldInit[type] + '[' + coords + ']' + boldEnd[type] + crlf[type];
	}
	else {
		nameCreated = colorInit[type].replace('#replace', color) + sizeInit[type].replace('#replace',size);
		nameCreated = nameCreated + playerName + ' ' + sizeEnd[type] + colorEnd[type] + crlf[type];
	}
	return nameCreated;
}

function createTecnology(tecnology, type) {
	tecnologyArr = tecnology.split(' ');
	tecnologyReport = t('Weapons') + ' ' + boldInit[type] + tecnologyArr[1] + boldEnd[type] + ' ' + t('Shields') + ' ';
	tecnologyReport = tecnologyReport + boldInit[type] + tecnologyArr[3] + boldEnd[type] + ' ' + t('Armour') + ' ';
	tecnologyReport = tecnologyReport + boldInit[type] + tecnologyArr[5] + boldEnd[type] +crlf[type];
	return tecnologyReport;
}

function estimateLooses (initialShipsType,initialShipsNumber, finalShipsNumber, type, totalLoosesColor, partialLoosesColor, isAtacker) {
	var metalLoosesPlayer = 0;
	var cristalLoosesPlayer = 0;
	var deuteriumLoosesPlayer = 0;
	    cristalDefendersLooses = 0;
    var serverShiptsNames= tag('$ships');
    var serverDefensesNames= tag('$defenses');
	for (var i=0; i<initialShipsType.length; i++) {
		//Search for initialShipsType in serverShiptsNames to get shipt values
		searchPos = -1;
		for ( var j=0;j<serverShiptsNames.length; j++ ) {
			if (initialShipsType[i] == serverShiptsNames[j]) {
				searchPos = j;
				 break;
			}
		}
		if (searchPos == -1) {
			//it's a defense :)
			for ( var j=0;j<serverDefensesNames.length; j++ ) {
				if (initialShipsType[i] == serverDefensesNames[j]) {
					searchPos = j;
				 	break;
				}
			}
			if (searchPos != -1) {
				metalLoosesPlayer = parseInt(metalLoosesPlayer) + parseInt(defensesMetalCost[searchPos]*(initialShipsNumber[i]-finalShipsNumber[i]));
				cristalLoosesPlayer = cristalLoosesPlayer + defensesCristalCost[searchPos]*(initialShipsNumber[i]-finalShipsNumber[i]);
				deuteriumLoosesPlayer = deuteriumLoosesPlayer + defensesDeuteriumCost[searchPos]*(initialShipsNumber[i]-finalShipsNumber[i]);
			}
		}
		else {
			metalLoosesPlayer = metalLoosesPlayer + shiptsMetalCost[searchPos]*(initialShipsNumber[i]-finalShipsNumber[i]);
			cristalLoosesPlayer = cristalLoosesPlayer + shiptsCristalCost[searchPos]*(initialShipsNumber[i]-finalShipsNumber[i]);
			deuteriumLoosesPlayer = deuteriumLoosesPlayer + shiptsDeuteriumCost[searchPos]*(initialShipsNumber[i]-finalShipsNumber[i]);
		}
	}
	totalLoose = formatNmb(metalLoosesPlayer + cristalLoosesPlayer + deuteriumLoosesPlayer);
	estimateReport =  t('Looses') + boldInit[type] + colorInit[type].replace('#replace', totalLoosesColor) + totalLoose + colorEnd[type] + boldEnd[type] + t('units') + crlf[type];
	estimateReport = estimateReport + itallyInit[type] +'(';
	estimateReport = estimateReport + colorInit[type].replace('#replace', partialLoosesColor) + formatNmb(metalLoosesPlayer) + colorEnd[type] + t('MetalCaptured');
	estimateReport = estimateReport + colorInit[type].replace('#replace', partialLoosesColor) + formatNmb(cristalLoosesPlayer) + colorEnd[type] + t('CrystalCaptured');
	estimateReport = estimateReport + colorInit[type].replace('#replace', partialLoosesColor) + formatNmb(deuteriumLoosesPlayer) + colorEnd[type] + t('DeuteriumCaptured');
	estimateReport = estimateReport + ')' + itallyEnd[type] + crlf[type];
	if (isAtacker) {
		metalAtackersLooses += parseInt(metalLoosesPlayer);
		cristalAtackersLooses += parseInt(cristalLoosesPlayer);
	 	deuteriumAtackersLooses += parseInt(deuteriumLoosesPlayer);
	} else {
		metalDefendersLooses += parseInt(metalLoosesPlayer);
		cristalDefendersLooses += parseInt(cristalLoosesPlayer);
	 	deuteriumDefendersLooses += parseInt(deuteriumLoosesPlayer);
	}
	return estimateReport;
}

function deuteriumConsumption (shiptsType, shiptsNumber, origin, destination) {
	var duration = 0;
	var spd = 0;
	var searchPos = -1;
	var basicCosumption = 0;
	var consumption = 0;
	var dist = distance(origin,destination);
	//Get the minimal velocity
	var minSpeed = 100000000;
    var serverShiptsNames= tag('$ships');
	for (var i=0; i<shiptsType.length; i++) {
		searchPos = -1;
		for ( var j=0;j<serverShiptsNames.length; j++ ) {
			if (shiptsType[i] == serverShiptsNames[j]) {
				searchPos = j;
				break;
			}
		}
		if (searchPos != -1) {
			//Get the slowest ship
			if ( parseInt(shiptsSpeed[searchPos]) < parseInt(minSpeed) ) {
				minSpeed = shiptsSpeed[searchPos]
			}
		}
	}
	duration = Math.round((35000/10 * Math.sqrt(dist*10/minSpeed) + 10));
	for (i=0; i<shiptsType.length; i++) {
		//For each ship in the attack :)
		searchPos = -1;
		for ( var j=0;j<serverShiptsNames.length; j++ ) {
			if (shiptsType[i] == serverShiptsNames[j]) {
				searchPos = j;
			 	break;
			}
		}
		if (searchPos != -1) {
			spd = 35000/(duration * 1 - 10) * Math.sqrt(dist*10/shiptsSpeed[searchPos]);
			basicConsumption = shiptsConsumption[searchPos] * shiptsNumber[i];
			consumption += basicConsumption * dist / 35000 * ((spd / 10) + 1) * ((spd / 10) + 1);
		}
	}
	consumption = Math.round(consumption) + 1;
   return consumption;
}

function resultAndStolen (type, stolenColor) {
	resultAndStolenReport = boldInit[type] + result_info + boldEnd[type] + crlf[type];
	if ((!isNaN(stolenMetal) || !isNaN(stolenCristal) || !isNaN(stolenDeuterium)) && (stolenMetal != 0 || stolenCristal != 0 || stolenDeuterium != 0) ) {
		resultAndStolenReport = resultAndStolenReport + t('Capture') + colorInit[type].replace('#replace', stolenColor);
		resultAndStolenReport = resultAndStolenReport + boldInit[type] + formatNmb(stolenMetal) + boldEnd[type] + colorEnd[type];
		resultAndStolenReport = resultAndStolenReport + t('MetalCaptured') + colorInit[type].replace('#replace', stolenColor);
		resultAndStolenReport = resultAndStolenReport + boldInit[type] + formatNmb(stolenCristal) + boldEnd[type] + colorEnd[type];
		resultAndStolenReport = resultAndStolenReport + t('CrystalCaptured') + colorInit[type].replace('#replace', stolenColor);
		resultAndStolenReport = resultAndStolenReport + boldInit[type] + formatNmb(stolenDeuterium) + boldEnd[type] + colorEnd[type];
		resultAndStolenReport = resultAndStolenReport + t('DeuteriumCaptured') + crlf[type];
	}
	return resultAndStolenReport;
}

function partialRentability (positiveResource, negativeResource) {
	var porcentage = Math.round(((positiveResource - negativeResource)/negativeResource)*100);
	if (isNaN(porcentage)) {
		porcentage = 0+ '%';
	}
	else if (Math.abs(porcentage) == Infinity) {
		if ( porcentage < 0 ) {
			porcentage = t('MinRentability');
		}
		else {
			porcentage = t('MaxRentability');
		}
	}
	else {
		porcentage = porcentage + '%';
	}
	return porcentage;
}

function do_report_shareout(type, color_set)
{
  if(!shareOutAllowed || !GM_getValue('shareout_show',0)) return '';

  var shareout= shareout_calculate(GM_getValue('shareout_flote',0)*10, !GM_getValue('shareout_defenders',false));

  if(shareout==null) return '';

  var shareout_size= new Array('2px','16','','12pt','2');
  var playerPrefix = colorInit[type].replace('#replace', atackerNameColor[color_set]) + sizeInit[type].replace('#replace',nick_size[type]);
  var playerSuffix = sizeEnd[type] + colorEnd[type] + crlf[type];
  var totalPrefix  = boldInit[type] + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]) + sizeInit[type].replace('#replace', shareout_size[type]) ;
  var totalSuffix  = sizeEnd[type] + colorEnd[type] + boldEnd[type] + t('units') + crlf[type];
  var partialPrefix= colorInit[type].replace('#replace',stolenColor[color_set]) + boldInit[type];
  var partialSuffix= boldEnd[type] + colorEnd[type];
  var profitPrefix = colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]);
  var profitSuffix = colorEnd[type];
  var result= crlf[type] + crlf[type] + boldInit[type] + t('ShareOutTitle') + boldEnd[type] + crlf[type];

  var resources= shareout.resources;
  for(var name in resources.metal.flote) {

    var metal    = resources.metal.flote[name];
    var crystal  = resources.crystal.flote[name];
    var deuterium= resources.deuterium.flote[name];

    var total    = metal.amount+crystal.amount+deuterium.amount;
    var profit   = metal.profit+crystal.profit+deuterium.profit;
    var lost     = metal.lost  +crystal.lost  +deuterium.lost;

	result+= playerPrefix + name + playerSuffix;

    result+= totalPrefix + formatNmb(total) + totalSuffix;;

    result+= '(';
    result+= partialPrefix + formatNmb(metal.amount)     + partialSuffix + t('MetalCaptured');
    result+= partialPrefix + formatNmb(crystal.amount)   + partialSuffix + t('CrystalCaptured');
    result+= partialPrefix + formatNmb(deuterium.amount) + partialSuffix + t('DeuteriumCaptured');
    result+= ')'+crlf[type];

    result+= t('Profit');
    result+= profitPrefix;
    result+= formatNmb( profit ) + ' (' + parseInt(profit / lost * 100) + '%)';
    result+= profitSuffix;
    result+= t('units') + crlf[type];
  }
  return result;
}

function do_old_report (type,color_set, view_tecnology, view_coords, view_partials, view_deuterium, date_time) {
	var resultReport = '';
    //
    var serverShiptsNames  = tag('$ships');
    var serverDefensesNames= tag('$defenses');
    var userShiptsNames    = t('$ships');
    var userDefensesNames  = t('$defenses');
	//Print date
	if (date_time) {
		resultReport = boldInit[type] + t('BattleOfTheDay') + date + boldEnd[type] + crlf[type];
	}
	//Print rounds;
	resultReport = resultReport + t('BattleDuration') + sizeInit[type].replace('#replace',round_size[type]) + boldInit[type] + rounds + boldEnd[type] + sizeEnd[type] + t('rounds');
	resultReport = resultReport + crlf[type] + crlf[type];
	resultReport = resultReport + boldInit[type] + sizeInit[type].replace('#replace',section_size[type]);

	//Print atackers section
	if (atackerCount > 1) {
		resultReport = resultReport + t('Attackers');
	}
	else {
		resultReport = resultReport +  t('Attacker');
	}
	resultReport = resultReport + ' (' + atackerCount +')'+ sizeEnd[type] + boldEnd[type] + crlf[type];
	//Print atacker fleets
	for (var i=0; i<atackerName.length; i++) {
		resultReport = resultReport + createPlayerName(atackerName[i], view_coords, atackerNameColor[color_set], nick_size[type], type, atackerCoords[i]);
		if (view_tecnology) {
			resultReport = resultReport + createTecnology (atackerTecnology[i], type);
		}
		resultReport = resultReport + createFloteView(atackerInitialShipsType[i], atackerInitialShipsNumber[i],atackerFinalShipsNumber[i],fleetAtackerColor[color_set], infoColor[color_set], type);
		resultReport = resultReport + crlf[type];
		if (view_partials) {
			resultReport = resultReport + estimateLooses(atackerInitialShipsType[i],atackerInitialShipsNumber[i], atackerFinalShipsNumber[i], type, totalAtackerLoosesColor[color_set], partialAtackerLoosesColor[color_set], true);
		}
		if (view_deuterium) {
			resultReport = resultReport + boldInit[type] + t('DeuteriumConsumption') + colorInit[type].replace('#replace', atackerConsumptionColor[color_set]) + formatNmb(deuteriumConsumption(atackerInitialShipsType[i], atackerInitialShipsNumber[i], atackerCoords[i], defenderCoords[0])) + colorEnd[type] + t('units') + boldEnd[type] + crlf[type];
		}
		if (view_partials || view_deuterium) {
			resultReport = resultReport + crlf[type];
		}
	}

	//Print defenders section
	resultReport = resultReport + boldInit[type] + sizeInit[type].replace('#replace',section_size[type]);
	if (defenderCount > 1) {
		resultReport = resultReport + t('Defenders');
	}
	else {
		resultReport = resultReport +  t('Defender');
	}
	resultReport = resultReport + ' (' + defenderCount +')'+ sizeEnd[type] + boldEnd[type] + crlf[type];
	//Print defender fleets
	for (var i=0; i<defenderName.length; i++) {
		resultReport = resultReport + createPlayerName(defenderName[i], view_coords, defenderNameColor[color_set], nick_size[type], type, defenderCoords[i]);
		if (view_tecnology) {
			resultReport = resultReport + createTecnology (defenderTecnology[i], type);
		}
		if (defenderInitialShipsType[i] != tag('NoShipsDefenses')) {
			resultReport = resultReport + createFloteView(defenderInitialShipsType[i], defenderInitialShipsNumber[i],defenderFinalShipsNumber[i],fleetDefenderColor[color_set],infoColor[color_set], type);
		} else {
			//Defender has nothing
			resultReport = resultReport + t('NoShipsDefenses') + crlf[type];
		}
		resultReport = resultReport + crlf[type];
		if (view_partials) {
			resultReport = resultReport + estimateLooses(defenderInitialShipsType[i],defenderInitialShipsNumber[i], defenderFinalShipsNumber[i], type, totalDefenderLoosesColor[color_set], partialDefenderLoosesColor[color_set], false);
		}
		if (view_deuterium && i !=0) {
			resultReport = resultReport + boldInit[type] + t('DeuteriumConsumption') + colorInit[type].replace('#replace', defenderConsumptionColor[color_set]) + formatNmb(deuteriumConsumption(defenderInitialShipsType[i], defenderInitialShipsNumber[i], defenderCoords[i], defenderCoords[0])) + colorEnd[type] + t('units') + boldEnd[type] +  crlf[type];
		}
		if (view_partials || (view_deuterium && i !=0)) {
			resultReport = resultReport + crlf[type];
		}
	}
	resultReport = resultReport + hr[type].replace('#replace',GM_getValue('hr_image',imageDefault));
	resultReport = resultReport + crlf[type];
	resultReport = resultReport + resultAndStolen(type, stolenColor[color_set]);
	resultReport = resultReport + crlf[type];
	//Looses
	if (atackerCount > 1) {
		resultReport = resultReport + t('LoosesMultiple') + t('Attackers');
	}
	else {
		resultReport = resultReport + t('LoosesSingle') + t('Attacker');
	}
	resultReport = resultReport + ': ' + sizeInit[type].replace('#replace', resource_size[type]) + colorInit[type].replace('#replace', totalAtackerLoosesColor[color_set])  + formatNmb(atackerLoosesAmount) + colorEnd[type] + sizeEnd[type] + t('units') + crlf[type];
	if (defenderCount > 1) {
		resultReport = resultReport + t('LoosesMultiple') + t('Defenders');
	}
	else {
		resultReport = resultReport + t('LoosesSingle') + t('Defender');
	}
	resultReport = resultReport + ': ' + sizeInit[type].replace('#replace', resource_size[type]) + colorInit[type].replace('#replace', totalDefenderLoosesColor[color_set])  + formatNmb(defenderLoosesAmount) + colorEnd[type] + sizeEnd[type] + t('units') + crlf[type];
	//total looses
	resultReport = resultReport + t('TotalLooses') + boldInit[type] + sizeInit[type].replace('#replace',rentability_size[type]);
	resultReport = resultReport + formatNmb(atackerLoosesAmount + defenderLoosesAmount);
	resultReport = resultReport + sizeEnd[type] + boldEnd[type] + t('units') + crlf[type] + crlf[type];
	//Rubles recicles
	if ((parseInt(rubbleCristal)+parseInt(rubbleMetal)) == 0) {
		resultReport = resultReport + boldInit[type] + t('Rubbles') + boldEnd[type] + crlf[type];
	}
	else {
		resultReport = resultReport + boldInit[type] + t('Rubbles') + boldEnd[type] + ' (';
		resultReport = resultReport + formatNmb(Math.floor((20000+parseInt(rubbleMetal)+parseInt(rubbleCristal))/20000));
		resultReport = resultReport + ' ' + serverShiptsNames[7] + ')' + crlf[type];

	}

	//rubbles partials
	resultReport = resultReport + t('MetalRubble') +  colorInit[type].replace('#replace', infoColor[color_set])  + boldInit[type];
	resultReport = resultReport + formatNmb(rubbleMetal) + boldEnd[type] + colorEnd[type] + t('units') + crlf[type];
	resultReport = resultReport + t('CrystalRubble') + colorInit[type].replace('#replace', infoColor[color_set]) + boldInit[type];
	resultReport = resultReport + formatNmb(rubbleCristal) + boldEnd[type] + colorEnd[type] + t('units') + crlf[type];

	//Win and looses
	resultReport = resultReport + crlf[type] + boldInit[type] + t('WinAndLost') + boldEnd[type] + crlf[type];
	if (atackerCount == 1) {
		resultReport = resultReport + t('AttackerRentability');
	}
	else {
		resultReport = resultReport + t('AttackersRentability');
	}
	resultReport = resultReport + sizeInit[type].replace('#replace', rentability_size[type]) + boldInit[type] + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]) + t(atackerRentability) + colorEnd[type] + boldEnd[type] + sizeEnd[type] + crlf[type];
	rentability = formatNmb((parseInt(rubbleMetal)+parseInt(rubbleCristal)+parseInt(stolenMetal)+parseInt(stolenCristal)+parseInt(stolenDeuterium))-atackerLoosesAmount);
	resultReport = resultReport + t('Attacker') + ' ' + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]) + ' ' + t('With') + colorEnd[type] + '/' + colorInit[type].replace('#replace', totalAtackerLoosesColor[color_set]) + t('Without') + colorEnd[type] + t('Recicle') + sizeInit[type].replace('#replace', rentability_size[type]) + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]) + rentability + colorEnd[type] + '/';
	rentability = formatNmb((parseInt(stolenMetal)+parseInt(stolenCristal)+parseInt(stolenDeuterium))-atackerLoosesAmount);
 	resultReport = resultReport + colorInit[type].replace('#replace', totalAtackerLoosesColor[color_set]) + rentability + colorEnd[type] + sizeEnd[type] + t('units') + crlf[type];

	if (defenderCount > 1) {
		resultReport = resultReport + t('DefendersWithRecicle');
	}
	else {
		resultReport = resultReport + t('DefenderWithRecicle');
	}
	rentability = formatNmb((parseInt(rubbleMetal) + parseInt(rubbleCristal) - stolenMetal - stolenCristal - stolenDeuterium)-parseInt(defenderLoosesAmount));
	resultReport = resultReport + sizeInit[type].replace('#replace', rentability_size[type]) + colorInit[type].replace('#replace', defenderWithRecicleColor[color_set]) + rentability;
	resultReport = resultReport + colorEnd[type] + sizeEnd[type] + t('units') + crlf[type];

	//Moon and defenses info :)

	if (moon_probability > 0) {
		var moonResult= moon_and_defenses_info.replace(moon_probability + ' %', sizeInit[type].replace('#replace',round_size[type]) + boldInit[type] +moon_probability+'%'+boldEnd[type] + sizeEnd[type]).replace( tag('MoonCreated'),boldInit[type] + tag('MoonCreated') + boldEnd[type]).replace(/<br>/g,crlf[type]);
        resultReport += moonResult.replace(tag('moon'),t('MoonChance')).replace(tag('MoonCreated'),t('MoonCreated'));
	}
	else {
		resultReport = resultReport + moon_and_defenses_info.replace(/<br>/g,crlf[type]);
	}

    resultReport+= do_report_shareout(type,color_set);

	resultReport = resultReport + crlf[type] + crlf[type] + t('$AddedLink')[type];
	for (i = 0; i < userShiptsNames.length; i ++) {
		reg = new RegExp(serverShiptsNames[i], "g")
		resultReport = resultReport.replace(reg,userShiptsNames[i]);
		reg = null;
	}
	for (i = 0; i < userDefensesNames.length; i ++) {
		reg = new RegExp(serverDefensesNames[i], "g")
		resultReport = resultReport.replace(reg,userDefensesNames[i]);
		reg = null;
	}
	//Reset the looses :)
	cristalAtackersLooses = 0;
	metalAtackersLooses = 0;
	deuteriumAtackersLooses = 0;
	metalDefendersLooses = 0;
	cristalDefenderLooses = 0;
	deuteriumDefendersLooses = 0;

    return resultReport;
}

function do_report (type,color_set, view_tecnology, view_coords, view_partials, view_deuterium, date_time) {

	var resultReport = '';
    //
    var serverShiptsNames= tag('$ships');
    var serverDefensesNames= tag('$defenses');
    var userShiptsNames    = t('$ships');
    var userDefensesNames  = t('$defenses');
	//Print date
	if (date_time) 
	{
		resultReport = boldInit[type] + t('BattleOfTheDay') + date + boldEnd[type] + crlf[type];
	}
	//Print rounds;
	resultReport = resultReport + t('BattleDuration') + sizeInit[type].replace('#replace',round_size[type]) + boldInit[type] + rounds + boldEnd[type] + sizeEnd[type] + t('rounds');
	resultReport = resultReport + crlf[type] + crlf[type];
	resultReport = resultReport + boldInit[type] + sizeInit[type].replace('#replace',section_size[type]);

	//Print atackers section
	if (atackerCount > 1) {
		resultReport = resultReport + t('Attackers');
	}
	else {
		resultReport = resultReport +  t('Attacker');
	}
	resultReport = resultReport + ' (' + atackerCount +')'+ sizeEnd[type] + boldEnd[type] + crlf[type];
	//Print atacker fleets
	for (var i=0; i<atackerName.length; i++) {
		resultReport = resultReport + createPlayerName(atackerName[i], view_coords, atackerNameColor[color_set], nick_size[type], type, atackerCoords[i]);
		if (view_tecnology) {
			resultReport = resultReport + createTecnology (atackerTecnology[i], type);
		}
		resultReport = resultReport + createFloteView(atackerInitialShipsType[i], atackerInitialShipsNumber[i],atackerFinalShipsNumber[i],fleetAtackerColor[color_set], infoColor[color_set], type);
		resultReport = resultReport + crlf[type];
		if (view_partials) {
			resultReport = resultReport + estimateLooses(atackerInitialShipsType[i],atackerInitialShipsNumber[i], atackerFinalShipsNumber[i], type, totalAtackerLoosesColor[color_set], partialAtackerLoosesColor[color_set], true);
		}
		if (view_deuterium) {
			resultReport = resultReport + boldInit[type] + t('DeuteriumConsumption') + colorInit[type].replace('#replace', atackerConsumptionColor[color_set]) + formatNmb(deuteriumConsumption(atackerInitialShipsType[i], atackerInitialShipsNumber[i], atackerCoords[i], defenderCoords[0])) + colorEnd[type] + t('units') + boldEnd[type] + crlf[type];
		}
		if (view_partials || view_deuterium) {
			resultReport = resultReport + crlf[type];
		}
	}

	//Print defenders section
	resultReport = resultReport + boldInit[type] + sizeInit[type].replace('#replace',section_size[type]);
	if (defenderCount > 1) {
		resultReport = resultReport + t('Defenders');
	}
	else {
		resultReport = resultReport +  t('Defender');
	}
	resultReport = resultReport + ' (' + defenderCount +')'+ sizeEnd[type] + boldEnd[type] + crlf[type];
	//Print defender fleets
	for (var i=0; i<defenderName.length; i++) {
		resultReport = resultReport + createPlayerName(defenderName[i], view_coords, defenderNameColor[color_set], nick_size[type], type, defenderCoords[i]);
		if (view_tecnology) {
			resultReport = resultReport + createTecnology (defenderTecnology[i], type);
		}
		if (defenderInitialShipsType[i] != tag('NoShipsDefenses')) {
			resultReport = resultReport + createFloteView(defenderInitialShipsType[i], defenderInitialShipsNumber[i],defenderFinalShipsNumber[i],fleetDefenderColor[color_set],infoColor[color_set], type);
		} else {
			//Defender has nothing
			resultReport = resultReport + t('NoShipsDefenses') + crlf[type];
		}
		resultReport = resultReport + crlf[type];
		if (view_partials) {
			resultReport = resultReport + estimateLooses(defenderInitialShipsType[i],defenderInitialShipsNumber[i], defenderFinalShipsNumber[i], type, totalDefenderLoosesColor[color_set], partialDefenderLoosesColor[color_set], false);
		}
		if (view_deuterium && i !=0) {
			resultReport = resultReport + boldInit[type] + t('DeuteriumConsumption') + colorInit[type].replace('#replace', defenderConsumptionColor[color_set]) + formatNmb(deuteriumConsumption(defenderInitialShipsType[i], defenderInitialShipsNumber[i], defenderCoords[i], defenderCoords[0])) + colorEnd[type] + t('units') + boldEnd[type] +  crlf[type];
		}
		if (view_partials || (view_deuterium && i !=0)) {
			resultReport = resultReport + crlf[type];
		}
	}
	resultReport = resultReport + hr[type].replace('#replace',GM_getValue('hr_image',imageDefault));
	resultReport = resultReport + crlf[type];
	resultReport = resultReport + resultAndStolen(type, stolenColor[color_set]);
	resultReport = resultReport + crlf[type];

	//ATACKER
	resultReport = resultReport + sizeInit[type].replace('#replace',rentability_size[type]);
	if (atackerCount > 1) {
		resultReport = resultReport + t('Attackers');
	}
	else {
		resultReport = resultReport + t('Attacker');
	}
	resultReport = resultReport + sizeEnd[type] + crlf[type];
	resultReport = resultReport + boldInit[type] + t('Looses') + boldEnd[type] + sizeInit[type].replace('#replace',round_size[type]);
	resultReport = resultReport + colorInit[type].replace('#replace', totalAtackerLoosesColor[color_set])  + formatNmb(atackerLoosesAmount) + colorEnd[type];
	resultReport = resultReport + sizeEnd[type] + t('units');
	resultReport = resultReport + crlf[type];

	//Atackers rentability with recicle
	resultReport = resultReport + boldInit[type] + t('RentabilityRecicle') +  ' ' +  sizeInit[type].replace('#replace',rentability_size[type]);
	rentability = formatNmb((parseInt(rubbleMetal)+parseInt(rubbleCristal)+parseInt(stolenMetal)+parseInt(stolenCristal)+parseInt(stolenDeuterium))-atackerLoosesAmount);
	resultReport = resultReport + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]) + rentability + ' (' + t(atackerRentability)  + ') ';

	resultReport = resultReport + colorEnd[type] + sizeEnd[type] + boldEnd[type] + t('units') + crlf[type];
	if (view_partials) {
			//Metal
			positive = parseInt(stolenMetal)+parseInt(rubbleMetal);
			negative = parseInt(metalAtackersLooses);
			resultReport = resultReport +  itallyInit[type] + t('MetalRubble') + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(positive-negative)  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
			//Cristal
			positive = parseInt(stolenCristal)+parseInt(rubbleCristal);
			negative = parseInt(cristalAtackersLooses);
			resultReport = resultReport +  itallyInit[type] + t('CrystalRubble') + colorInit[type].replace('#replace', atackerWithRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(parseInt(positive) - parseInt(negative))  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
	}
	//Atackers rentability without recicle
	resultReport = resultReport + boldInit[type] + t('RentabilityNoRecicle') +  ' ' +  sizeInit[type].replace('#replace',rentability_size[type]);
	rentability = formatNmb((parseInt(stolenMetal)+parseInt(stolenCristal)+parseInt(stolenDeuterium))-atackerLoosesAmount);
	resultReport = resultReport + colorInit[type].replace('#replace', atackerWithOutRecicleColor[color_set]) + rentability + ' (' + t(atackerRentability2)  + ') ';
	resultReport = resultReport + colorEnd[type] + sizeEnd[type] + boldEnd[type] + t('units') + crlf[type];
	if (view_partials) {
			//Metal
			positive = parseInt(stolenMetal);
			negative = parseInt(metalAtackersLooses);
			resultReport = resultReport +  itallyInit[type] + t('MetalRubble') + colorInit[type].replace('#replace', atackerWithOutRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(positive-negative)  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
			//Cristal
			positive = parseInt(stolenCristal);
			negative = parseInt(cristalAtackersLooses);
			resultReport = resultReport +  itallyInit[type] + t('CrystalRubble') + colorInit[type].replace('#replace', atackerWithOutRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(parseInt(positive) - parseInt(negative))  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
			//Deuterium
			positive = parseInt(stolenDeuterium);
			negative = parseInt(deuteriumAtackersLooses);
			resultReport = resultReport +  itallyInit[type] + t('DeuteriumRubble') + colorInit[type].replace('#replace', atackerWithOutRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(parseInt(positive) - parseInt(negative))  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
	}
	resultReport = resultReport + crlf[type];
	//DEFEDER
	resultReport = resultReport + sizeInit[type].replace('#replace',rentability_size[type]);
	if (defenderCount > 1) {
		resultReport = resultReport + t('Defenders');
	}
	else {
		resultReport = resultReport + t('Defender');
	}
	resultReport = resultReport + sizeEnd[type] + crlf[type];
	resultReport = resultReport + boldInit[type] + t('Looses') + boldEnd[type] + sizeInit[type].replace('#replace',round_size[type]);
	resultReport = resultReport + colorInit[type].replace('#replace', totalDefenderLoosesColor[color_set])  + formatNmb(defenderLoosesAmount) + colorEnd[type];
	resultReport = resultReport + sizeEnd[type] + t('units');
	resultReport = resultReport + crlf[type];

	//Defenders rentability with recicle
	resultReport = resultReport + boldInit[type] + t('RentabilityRecicle') +  ' ' +  sizeInit[type].replace('#replace',rentability_size[type]);
	rentability = formatNmb((parseInt(rubbleMetal) + parseInt(rubbleCristal) - stolenMetal - stolenCristal - stolenDeuterium)-parseInt(defenderLoosesAmount));
	resultReport = resultReport + colorInit[type].replace('#replace', defenderWithRecicleColor[color_set]) + rentability + ' (' + t(defenderRentability)  + ') ';
	resultReport = resultReport + colorEnd[type] + sizeEnd[type] + boldEnd[type] + t('units') + crlf[type];
	if (view_partials) {
			//Metal
			positive = parseInt(rubbleMetal);
			negative = parseInt(stolenMetal)+parseInt(metalDefendersLooses);
			resultReport = resultReport +  itallyInit[type] + t('MetalRubble') + colorInit[type].replace('#replace', defenderWithRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(positive-negative)  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
			//Cristal
			positive = parseInt(rubbleCristal);
			negative = parseInt(stolenCristal)+parseInt(cristalDefendersLooses);
			resultReport = resultReport +  itallyInit[type] + t('CrystalRubble') + colorInit[type].replace('#replace', defenderWithRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(parseInt(positive) - parseInt(negative))  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
			//Deuterium
			positive = 0;
			negative = parseInt(deuteriumDefendersLooses)+parseInt(stolenDeuterium);
			resultReport = resultReport +  itallyInit[type] + t('DeuteriumRubble') + colorInit[type].replace('#replace', defenderWithRecicleColor[color_set]);
			resultReport = resultReport + formatNmb(parseInt(positive) - parseInt(negative))  + ' (' + partialRentability(positive,negative) + ') ';
			resultReport = resultReport + colorEnd[type] + itallyEnd[type] + crlf[type];
	}
	resultReport = resultReport + crlf[type];

	//Total Looses
	resultReport = resultReport + t('TotalLooses') + boldInit[type] + sizeInit[type].replace('#replace',rentability_size[type]);
	resultReport = resultReport + formatNmb(atackerLoosesAmount + defenderLoosesAmount);
	resultReport = resultReport + sizeEnd[type] + boldEnd[type] + t('units') + crlf[type]
	resultReport = resultReport + crlf[type];

	//Rubles recicles
	if ((parseInt(rubbleCristal)+parseInt(rubbleMetal)) == 0) {
		resultReport = resultReport + boldInit[type] + t('Rubbles') + boldEnd[type] + crlf[type];
	}
	else {
		resultReport = resultReport + boldInit[type] + t('Rubbles') + boldEnd[type] + ' (';
		resultReport = resultReport + formatNmb(Math.floor((20000+parseInt(rubbleMetal)+parseInt(rubbleCristal))/20000));
		resultReport = resultReport + ' ' + serverShiptsNames[7] + ')' + crlf[type];

	}

	//rubbles partials
	resultReport = resultReport + t('MetalRubble') +  colorInit[type].replace('#replace', infoColor[color_set])  + boldInit[type];
	resultReport = resultReport + formatNmb(rubbleMetal) + boldEnd[type] + colorEnd[type] + t('units') + crlf[type];
	resultReport = resultReport + t('CrystalRubble') + colorInit[type].replace('#replace', infoColor[color_set]) + boldInit[type];
	resultReport = resultReport + formatNmb(rubbleCristal) + boldEnd[type] + colorEnd[type] + t('units') + crlf[type];

	//Moon and defenses info :)

	if (moon_probability > 0) {
		var moonResult=  moon_and_defenses_info.replace(moon_probability + ' %', sizeInit[type].replace('#replace',round_size[type]) + boldInit[type] +moon_probability+'%'+boldEnd[type] + sizeEnd[type]).replace(tag('MoonCreated'),boldInit[type] + tag('MoonCreated') + boldEnd[type]).replace(/<br>/g,crlf[type]);
        resultReport += moonResult.replace(tag('moon'),t('MoonChance')).replace(tag('MoonCreated'),t('MoonCreated'));
	}
	else {
		resultReport = resultReport + moon_and_defenses_info.replace(/<br>/g,crlf[type]);
	}

    resultReport+= do_report_shareout(type,color_set);

	resultReport = resultReport + crlf[type] + crlf[type] + t('$AddedLink')[type];
	for (i = 0; i < userShiptsNames.length; i ++) {
		reg = new RegExp(serverShiptsNames[i], "g")
		resultReport = resultReport.replace(reg,userShiptsNames[i]);
		reg = null;
	}
	for (i = 0; i < userDefensesNames.length; i ++) {
		reg = new RegExp(serverDefensesNames[i], "g")
		resultReport = resultReport.replace(reg,userDefensesNames[i]);
		reg = null;
	}
	//Reset the looses :)
	cristalAtackersLooses = 0;
	metalAtackersLooses = 0;
	deuteriumAtackersLooses = 0;
	metalDefendersLooses = 0;
	cristalDefenderLooses = 0;
	deuteriumDefendersLooses = 0;

	return resultReport;
}

function create_report()
{
  if (atackerName.length > 0) {
    // Set original report visibility
    report_original.style.display= GM_getValue('hide_report',false) ? 'none' : 'block';
    // Calculate report function to execute
    var exec_report= GM_getValue('old_favour',false) ? do_old_report : do_report;
    // Report for forums
    var forum_type = GM_getValue('forum_type',1);
    var light_forum= GM_getValue('light_forum',true) ? 0 : 1;
    var date_time = GM_getValue('date_time',true) ? 1 : 0;
    try {
       report_input.innerHTML= exec_report(forum_type,light_forum,GM_getValue('tecnology',false),GM_getValue('coords',false), GM_getValue('partials',false) , GM_getValue('deuterium',false), date_time);
    } catch (error) {
       report_input.innerHTML= do_report(1,1,false,false,false, false, true);
    }
    // Report to replace ugly ogame battle
    var light_skin= GM_getValue('light_skin',false) ? 0 : 1;
    try {
       report_div.innerHTML= exec_report(0,light_skin,true,true, GM_getValue('partials',false), GM_getValue('deuterium',false), true);
    } catch (error) {
       report_div.innerHTML= do_old_report(0,1,true,true, true, true, true);
    }
  }
}

function create_view()
{
  // Style rules
  var sheet= document.styleSheets[0];
  sheet.insertRule('#report { color:white; margin-left: 15px; margin-top:15px; font-family: Tahoma,sans-serif;  font-size: 11px; }',0);
  // Original ogame ugly battle
  report_original= document.getElementsByTagName('table')[0];
  report_original.id ="report_original";
  // DIV for the new html report (replacing ugly ogame report)
  report_div   = document.createElement("div");
  report_div.id = "report";
  document.body.insertBefore(report_div,  report_original);
  // Input for the zipped report for forums (phpBB,smf,etc)
  report_input   = document.createElement("textarea");
  report_input.id= "forum_compactation";
  report_input.style.display='none';
  document.body.insertBefore(report_input, report_original);
  //
  create_report();
}

/////////////////////////////////////////////////////////////////
// Call parser functions useful to take decisions about report //
// like color, tecnology, and coords			               //
/////////////////////////////////////////////////////////////////

function get_parts_from_web ()
{
try {
  get_locale();
  date = get_battle_date();
  get_names_and_flotes();
  get_final_flotes ();
  get_rounds();
  get_battle_info_result();
  get_rentabilitys ();
  shareout_init();
  create_view();
  create_report();
} catch (err) {};
}

////////////////
// BEGIN HERE //
////////////////


get_parts_from_web();
